## gradm2 2.0.1

=== Makefile ===
##############################################################################
#gradm (c) 2002,2003,2004 Brad Spengler 	        http://grsecurity.net#
#--------------------------------------			---------------------#
#gradm is licensed under the GNU GPL http://www.gnu.org		             #
##############################################################################

GRADM_BIN=gradm
GRSEC_DIR=/etc/grsec

LEX=/usr/bin/lex
FLEX=/usr/bin/flex
LEXFLAGS=-B
YACC=/usr/bin/yacc
BYACC=/usr/bin/byacc
BISON=/usr/bin/bison
MKNOD=/bin/mknod
#for dietlibc
#CC=/usr/bin/diet /usr/bin/gcc
CC=/usr/bin/gcc
FIND=/usr/bin/find
STRIP=/usr/bin/strip
KERNVER=`uname -r | cut -d"." -f 2`
LIBS = $(shell if [ "`uname -m`" != "sparc64" ]; then echo "-lfl" ; else echo "" ; fi)
OPT_FLAGS = $(shell if [ "`uname -m`" != "sparc64" ]; then echo "-O2" ; else echo "-O2 -m64" ; fi)
CFLAGS=$(OPT_FLAGS) -DGRSEC_DIR=\"$(GRSEC_DIR)\" -DKERNVER=$(KERNVER)
LDFLAGS=
INSTALL = /usr/bin/install -c

# FHS
MANDIR=/usr/share/man
# older MANDIR
#MANDIR=/usr/man
DESTDIR=

OBJECTS=gradm.tab.o lex.gradm.o learn_pass1.tab.o learn_pass2.tab.o \
	fulllearn_pass1.tab.o fulllearn_pass2.tab.o fulllearn_pass3.tab.o \
	gradm_misc.o gradm_parse.o gradm_arg.o gradm_pw.o gradm_opt.o \
	gradm_cap.o gradm_sha256.o gradm_adm.o gradm_analyze.o gradm_res.o \
	gradm_human.o gradm_learn.o gradm_net.o gradm_nest.o \
	gradm_sym.o gradm_newlearn.o gradm_fulllearn.o gradm_lib.o \
	lex.fulllearn_pass1.o lex.fulllearn_pass2.o \
	lex.fulllearn_pass3.o lex.learn_pass1.o lex.learn_pass2.o

all: $(USE_YACC) $(USE_LEX) $(GRADM_BIN) grlearn

USE_YACC = $(shell if [ -x $(BYACC) ]; then echo $(BYACC); \
	else if [ -x $(BISON) ]; then echo $(BISON) -y; \
	else if [ -x $(YACC) ]; then echo $(YACC); \
	else \
		echo "Bison/(b)yacc needs to be installed to compile gradm."; \
		exit 1; \
	fi;fi;fi)

USE_LEX = $(shell if [ -x $(FLEX) ]; then echo $(FLEX); \
	else if [ -x $(LEX) ]; then echo $(LEX); \
	else \
		echo "(f)Lex needs to be installed to compile gradm."; \
		exit 1; \
	fi;fi)

$(GRADM_BIN): $(OBJECTS)
	$(CC) $(CFLAGS) -o $@ $(OBJECTS) $(LIBS) $(LDFLAGS)

grlearn: grlearn.c gradm_lib.c
	$(CC) $(CFLAGS) -o $@ grlearn.c gradm_lib.c $(LIBS) $(LDFLAGS)


gradm.tab.c: gradm.y
	$(USE_YACC) -b gradm -p gradm -d ./gradm.y

lex.gradm.c: gradm.l
	$(USE_LEX) $(LEXFLAGS) -Pgradm ./gradm.l

fulllearn_pass1.tab.c: gradm_fulllearn_pass1.y
	$(USE_YACC) -b fulllearn_pass1 -p fulllearn_pass1 -d ./gradm_fulllearn_pass1.y
fulllearn_pass2.tab.c: gradm_fulllearn_pass2.y
	$(USE_YACC) -b fulllearn_pass2 -p fulllearn_pass2 -d ./gradm_fulllearn_pass2.y
fulllearn_pass3.tab.c: gradm_fulllearn_pass3.y
	$(USE_YACC) -b fulllearn_pass3 -p fulllearn_pass3 -d ./gradm_fulllearn_pass3.y

lex.fulllearn_pass1.c: gradm_fulllearn_pass1.l
	$(USE_LEX) $(LEXFLAGS) -Pfulllearn_pass1 ./gradm_fulllearn_pass1.l
lex.fulllearn_pass2.c: gradm_fulllearn_pass2.l
	$(USE_LEX) $(LEXFLAGS) -Pfulllearn_pass2 ./gradm_fulllearn_pass2.l
lex.fulllearn_pass3.c: gradm_fulllearn_pass3.l
	$(USE_LEX) $(LEXFLAGS) -Pfulllearn_pass3 ./gradm_fulllearn_pass3.l

learn_pass1.tab.c: gradm_learn_pass1.y
	$(USE_YACC) -b learn_pass1 -p learn_pass1 -d ./gradm_learn_pass1.y
learn_pass2.tab.c: gradm_learn_pass2.y
	$(USE_YACC) -b learn_pass2 -p learn_pass2 -d ./gradm_learn_pass2.y

lex.learn_pass1.c: gradm_learn_pass1.l
	$(USE_LEX) $(LEXFLAGS) -Plearn_pass1 ./gradm_learn_pass1.l
lex.learn_pass2.c: gradm_learn_pass2.l
	$(USE_LEX) $(LEXFLAGS) -Plearn_pass2 ./gradm_learn_pass2.l

install: $(GRADM_BIN) gradm.8 policy grlearn
	mkdir -p $(DESTDIR)/sbin
	$(INSTALL) -m 0755 $(GRADM_BIN) $(DESTDIR)/sbin
	$(STRIP) $(DESTDIR)/sbin/$(GRADM_BIN)
	$(INSTALL) -m 0700 grlearn $(DESTDIR)/sbin
	$(STRIP) $(DESTDIR)/sbin/grlearn
	mkdir -p -m 700 $(DESTDIR)$(GRSEC_DIR)
	@if [ ! -f $(DESTDIR)$(GRSEC_DIR)/policy ] ; then \
		if [ -f $(DESTDIR)$(GRSEC_DIR)/acl ] ; then \
			mv $(DESTDIR)$(GRSEC_DIR)/acl $(DESTDIR)$(GRSEC_DIR)/policy ; \
		else \
			$(INSTALL) -m 0600 policy $(DESTDIR)$(GRSEC_DIR) ; \
		fi \
	fi
	@if [ -z "`cut -d" " -f3 /proc/mounts | grep "^devfs"`" ] ; then \
		rm -f $(DESTDIR)/dev/grsec ; \
		if [ ! -e $(DESTDIR)/dev/grsec ] ; then \
			mkdir -p $(DESTDIR)/dev ; \
			$(MKNOD) -m 0622 $(DESTDIR)/dev/grsec c 1 12 ; \
		fi \
	fi
	mkdir -p $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -m 0644 gradm.8 $(DESTDIR)$(MANDIR)/man8/$(GRADM_BIN).8
	@if [ -z $(DESTDIR) ] ; then \
		if [ -x /sbin/$(GRADM_BIN) ] ; then \
			$(FIND) $(GRSEC_DIR) -type f -name pw -size 48c -exec rm -f $(GRSEC_DIR)/pw \; ; \
			if [ ! -f $(GRSEC_DIR)/pw ] ; then \
				/sbin/$(GRADM_BIN) -P ; \
                        fi \
		fi \
	fi

clean:
	rm -f core *.o $(GRADM_BIN) lex.*.c *.tab.c *.tab.h grlearn

## gradm2 2.1.5

=== Makefile ===
##############################################################################
#gradm (c) 2002-2005 	Brad Spengler 		        http://grsecurity.net#
#--------------------------------------			---------------------#
#gradm is licensed under the GNU GPL v2 or higher http://www.gnu.org         #
##############################################################################

GRADM_BIN=gradm
GRSEC_DIR=/etc/grsec

LLEX=/usr/bin/lex
FLEX=/usr/bin/flex
LEX := $(shell if [ -x $(FLEX) ]; then echo $(FLEX); else echo $(LLEX); fi)
LEXFLAGS=-B
BYACC=/usr/bin/byacc
BISON=/usr/bin/bison
YACC := $(shell if [ -x $(BYACC) ]; then echo $(BYACC); else echo $(BISON); fi)
MKNOD=/bin/mknod
#for dietlibc
#CC=/usr/bin/diet /usr/bin/gcc
CC=/usr/bin/gcc
FIND=/usr/bin/find
STRIP=/usr/bin/strip
KERNVER := $(shell uname -r | cut -d"." -f 2)
LIBS := $(shell if [ "`uname -m`" != "sparc64" ]; then echo "-lfl" ; else echo "" ; fi)
OPT_FLAGS := $(shell if [ "`uname -m`" != "sparc64" ] && [ "`uname -m`" != "x86_64" ]; then echo "-O2" ; else echo "-O2 -m64" ; fi)
CFLAGS := $(OPT_FLAGS) -DGRSEC_DIR=\"$(GRSEC_DIR)\" -DKERNVER=$(KERNVER)
LDFLAGS=
INSTALL = /usr/bin/install -c

# FHS
MANDIR=/usr/share/man
# older MANDIR
#MANDIR=/usr/man
DESTDIR=

OBJECTS=gradm.tab.o lex.gradm.o learn_pass1.tab.o learn_pass2.tab.o \
	fulllearn_pass1.tab.o fulllearn_pass2.tab.o fulllearn_pass3.tab.o \
	gradm_misc.o gradm_parse.o gradm_arg.o gradm_pw.o gradm_opt.o \
	gradm_cap.o gradm_sha256.o gradm_adm.o gradm_analyze.o gradm_res.o \
	gradm_human.o gradm_learn.o gradm_net.o gradm_nest.o \
	gradm_sym.o gradm_newlearn.o gradm_fulllearn.o gradm_lib.o \
	lex.fulllearn_pass1.o lex.fulllearn_pass2.o \
	lex.fulllearn_pass3.o lex.learn_pass1.o lex.learn_pass2.o \
	grlearn_config.tab.o lex.grlearn_config.o

all: $(GRADM_BIN) grlearn

$(GRADM_BIN): $(OBJECTS)
	$(CC) $(CFLAGS) -o $@ $(OBJECTS) $(LIBS) $(LDFLAGS)

grlearn: grlearn.c gradm_lib.c
	$(CC) $(CFLAGS) -o $@ grlearn.c gradm_lib.c $(LIBS) $(LDFLAGS)


grlearn_config.tab.c: grlearn_config.y
	$(YACC) -b grlearn_config -p grlearn_config -d ./grlearn_config.y

lex.grlearn_config.c: grlearn_config.l
	$(LEX) $(LEXFLAGS) -Pgrlearn_config ./grlearn_config.l

gradm.tab.c: gradm.y
	$(YACC) -b gradm -p gradm -d ./gradm.y

lex.gradm.c: gradm.l
	$(LEX) $(LEXFLAGS) -Pgradm ./gradm.l

fulllearn_pass1.tab.c: gradm_fulllearn_pass1.y
	$(YACC) -b fulllearn_pass1 -p fulllearn_pass1 -d ./gradm_fulllearn_pass1.y
fulllearn_pass2.tab.c: gradm_fulllearn_pass2.y
	$(YACC) -b fulllearn_pass2 -p fulllearn_pass2 -d ./gradm_fulllearn_pass2.y
fulllearn_pass3.tab.c: gradm_fulllearn_pass3.y
	$(YACC) -b fulllearn_pass3 -p fulllearn_pass3 -d ./gradm_fulllearn_pass3.y

lex.fulllearn_pass1.c: gradm_fulllearn_pass1.l
	$(LEX) $(LEXFLAGS) -Pfulllearn_pass1 ./gradm_fulllearn_pass1.l
lex.fulllearn_pass2.c: gradm_fulllearn_pass2.l
	$(LEX) $(LEXFLAGS) -Pfulllearn_pass2 ./gradm_fulllearn_pass2.l
lex.fulllearn_pass3.c: gradm_fulllearn_pass3.l
	$(LEX) $(LEXFLAGS) -Pfulllearn_pass3 ./gradm_fulllearn_pass3.l

learn_pass1.tab.c: gradm_learn_pass1.y
	$(YACC) -b learn_pass1 -p learn_pass1 -d ./gradm_learn_pass1.y
learn_pass2.tab.c: gradm_learn_pass2.y
	$(YACC) -b learn_pass2 -p learn_pass2 -d ./gradm_learn_pass2.y

lex.learn_pass1.c: gradm_learn_pass1.l
	$(LEX) $(LEXFLAGS) -Plearn_pass1 ./gradm_learn_pass1.l
lex.learn_pass2.c: gradm_learn_pass2.l
	$(LEX) $(LEXFLAGS) -Plearn_pass2 ./gradm_learn_pass2.l

install: $(GRADM_BIN) gradm.8 policy grlearn
	mkdir -p $(DESTDIR)/sbin
	$(INSTALL) -m 0755 $(GRADM_BIN) $(DESTDIR)/sbin
	$(STRIP) $(DESTDIR)/sbin/$(GRADM_BIN)
	$(INSTALL) -m 0700 grlearn $(DESTDIR)/sbin
	$(STRIP) $(DESTDIR)/sbin/grlearn
	mkdir -p -m 700 $(DESTDIR)$(GRSEC_DIR)
	@if [ ! -f $(DESTDIR)$(GRSEC_DIR)/policy ] ; then \
		if [ -f $(DESTDIR)$(GRSEC_DIR)/acl ] ; then \
			mv $(DESTDIR)$(GRSEC_DIR)/acl $(DESTDIR)$(GRSEC_DIR)/policy ; \
		else \
			$(INSTALL) -m 0600 policy $(DESTDIR)$(GRSEC_DIR) ; \
		fi \
	fi
	@$(FIND) $(DESTDIR)$(GRSEC_DIR) -type f -name learn_config -size 1291c -exec rm -f $(DESTDIR)$(GRSEC_DIR)/learn_config \;
	@if [ ! -f $(DESTDIR)$(GRSEC_DIR)/learn_config ] ; then \
		$(INSTALL) -m 0600 learn_config $(DESTDIR)$(GRSEC_DIR) ; \
	fi
	@if [ -z "`cut -d" " -f3 /proc/mounts | grep "^devfs"`" ] ; then \
		rm -f $(DESTDIR)/dev/grsec ; \
		if [ ! -e $(DESTDIR)/dev/grsec ] ; then \
			mkdir -p $(DESTDIR)/dev ; \
			$(MKNOD) -m 0622 $(DESTDIR)/dev/grsec c 1 12 ; \
		fi \
	fi
	mkdir -p $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -m 0644 gradm.8 $(DESTDIR)$(MANDIR)/man8/$(GRADM_BIN).8
	@if [ -x /sbin/$(GRADM_BIN) ] ; then \
		if [ -z $(DESTDIR) ] && [ ! -f $(GRSEC_DIR)/pw ] ; then \
			/sbin/$(GRADM_BIN) -P ; \
		fi \
	fi
	@true

clean:
	rm -f core *.o $(GRADM_BIN) lex.*.c *.tab.c *.tab.h grlearn

## gradm2 2.1.6

=== Makefile ===
--- 
+++ 
@@ -5,6 +5,7 @@
 ##############################################################################
 
 GRADM_BIN=gradm
+GRADM_PAM=gradm_pam
 GRSEC_DIR=/etc/grsec
 
 LLEX=/usr/bin/lex
@@ -20,10 +21,9 @@
 CC=/usr/bin/gcc
 FIND=/usr/bin/find
 STRIP=/usr/bin/strip
-KERNVER := $(shell uname -r | cut -d"." -f 2)
 LIBS := $(shell if [ "`uname -m`" != "sparc64" ]; then echo "-lfl" ; else echo "" ; fi)
 OPT_FLAGS := $(shell if [ "`uname -m`" != "sparc64" ] && [ "`uname -m`" != "x86_64" ]; then echo "-O2" ; else echo "-O2 -m64" ; fi)
-CFLAGS := $(OPT_FLAGS) -DGRSEC_DIR=\"$(GRSEC_DIR)\" -DKERNVER=$(KERNVER)
+CFLAGS := $(OPT_FLAGS) -DGRSEC_DIR=\"$(GRSEC_DIR)\"
 LDFLAGS=
 INSTALL = /usr/bin/install -c
 
@@ -43,14 +43,24 @@
 	lex.fulllearn_pass3.o lex.learn_pass1.o lex.learn_pass2.o \
 	grlearn_config.tab.o lex.grlearn_config.o
 
-all: $(GRADM_BIN) grlearn
+all: $(GRADM_BIN) $(GRADM_PAM) grlearn
+nopam: $(GRADM_BIN) grlearn
 
-$(GRADM_BIN): $(OBJECTS)
+$(GRADM_BIN): $(OBJECTS) gradm.h gradm_defs.h gradm_func.h
 	$(CC) $(CFLAGS) -o $@ $(OBJECTS) $(LIBS) $(LDFLAGS)
 
-grlearn: grlearn.c gradm_lib.c
-	$(CC) $(CFLAGS) -o $@ grlearn.c gradm_lib.c $(LIBS) $(LDFLAGS)
+$(GRADM_PAM): gradm_pam.c gradm.h gradm_defs.h gradm_func.h
+	@if [ ! -f /usr/include/security/pam_appl.h ] ; then \
+		echo "Unable to detect PAM headers, disabling PAM support." ; \
+	else \
+		$(CC) $(CFLAGS) -o $@ gradm_pam.c -lpam -lpam_misc $(LDFLAGS) ; \
+	fi
 
+grlearn: grlearn.c gradm_lib.c grlearn2_config.tab.c lex.grlearn_config.c
+	$(CC) $(CFLAGS) -DIS_GRLEARN -o $@ grlearn.c gradm_lib.c grlearn2_config.tab.c lex.grlearn_config.c $(LIBS) $(LDFLAGS)
+
+grlearn2_config.tab.c: grlearn2_config.y
+	$(YACC) -b grlearn2_config -p grlearn2_config -d ./grlearn2_config.y
 
 grlearn_config.tab.c: grlearn_config.y
 	$(YACC) -b grlearn_config -p grlearn_config -d ./grlearn_config.y
@@ -89,12 +99,19 @@
 	$(LEX) $(LEXFLAGS) -Plearn_pass2 ./gradm_learn_pass2.l
 
 install: $(GRADM_BIN) gradm.8 policy grlearn
-	mkdir -p $(DESTDIR)/sbin
-	$(INSTALL) -m 0755 $(GRADM_BIN) $(DESTDIR)/sbin
-	$(STRIP) $(DESTDIR)/sbin/$(GRADM_BIN)
-	$(INSTALL) -m 0700 grlearn $(DESTDIR)/sbin
-	$(STRIP) $(DESTDIR)/sbin/grlearn
-	mkdir -p -m 700 $(DESTDIR)$(GRSEC_DIR)
+	@mkdir -p $(DESTDIR)/sbin
+	@echo "Installing gradm..."
+	@$(INSTALL) -m 0755 $(GRADM_BIN) $(DESTDIR)/sbin
+	@$(STRIP) $(DESTDIR)/sbin/$(GRADM_BIN)
+	@if [ -f $(GRADM_PAM) ] ; then \
+		echo "Installing gradm_pam..." ; \
+		$(INSTALL) -m 4755 $(GRADM_PAM) $(DESTDIR)/sbin ; \
+		$(STRIP) $(DESTDIR)/sbin/$(GRADM_PAM) ; \
+	fi
+	@echo "Installing grlearn..."
+	@$(INSTALL) -m 0700 grlearn $(DESTDIR)/sbin
+	@$(STRIP) $(DESTDIR)/sbin/grlearn
+	@mkdir -p -m 700 $(DESTDIR)$(GRSEC_DIR)
 	@if [ ! -f $(DESTDIR)$(GRSEC_DIR)/policy ] ; then \
 		if [ -f $(DESTDIR)$(GRSEC_DIR)/acl ] ; then \
 			mv $(DESTDIR)$(GRSEC_DIR)/acl $(DESTDIR)$(GRSEC_DIR)/policy ; \
@@ -113,8 +130,9 @@
 			$(MKNOD) -m 0622 $(DESTDIR)/dev/grsec c 1 12 ; \
 		fi \
 	fi
-	mkdir -p $(DESTDIR)$(MANDIR)/man8
-	$(INSTALL) -m 0644 gradm.8 $(DESTDIR)$(MANDIR)/man8/$(GRADM_BIN).8
+	@echo "Installing gradm manpage..."
+	@mkdir -p $(DESTDIR)$(MANDIR)/man8
+	@$(INSTALL) -m 0644 gradm.8 $(DESTDIR)$(MANDIR)/man8/$(GRADM_BIN).8
 	@if [ -x /sbin/$(GRADM_BIN) ] ; then \
 		if [ -z $(DESTDIR) ] && [ ! -f $(GRSEC_DIR)/pw ] ; then \
 			/sbin/$(GRADM_BIN) -P ; \
@@ -123,4 +141,4 @@
 	@true
 
 clean:
-	rm -f core *.o $(GRADM_BIN) lex.*.c *.tab.c *.tab.h grlearn
+	rm -f core *.o $(GRADM_BIN) $(GRADM_PAM) lex.*.c *.tab.c *.tab.h grlearn

## gradm2 2.1.7

=== Makefile ===
--- 
+++ 
@@ -127,7 +127,7 @@
 		rm -f $(DESTDIR)/dev/grsec ; \
 		if [ ! -e $(DESTDIR)/dev/grsec ] ; then \
 			mkdir -p $(DESTDIR)/dev ; \
-			$(MKNOD) -m 0622 $(DESTDIR)/dev/grsec c 1 12 ; \
+			$(MKNOD) -m 0622 $(DESTDIR)/dev/grsec c 1 13 ; \
 		fi \
 	fi
 	@echo "Installing gradm manpage..."

## gradm2 2.1.9

=== Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 	fulllearn_pass1.tab.o fulllearn_pass2.tab.o fulllearn_pass3.tab.o \
 	gradm_misc.o gradm_parse.o gradm_arg.o gradm_pw.o gradm_opt.o \
 	gradm_cap.o gradm_sha256.o gradm_adm.o gradm_analyze.o gradm_res.o \
-	gradm_human.o gradm_learn.o gradm_net.o gradm_nest.o \
+	gradm_human.o gradm_learn.o gradm_net.o gradm_nest.o gradm_pax.o \
 	gradm_sym.o gradm_newlearn.o gradm_fulllearn.o gradm_lib.o \
 	lex.fulllearn_pass1.o lex.fulllearn_pass2.o \
 	lex.fulllearn_pass3.o lex.learn_pass1.o lex.learn_pass2.o \

## gradm2 2.1.11

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 ##############################################################################
-#gradm (c) 2002-2005 	Brad Spengler 		        http://grsecurity.net#
+#gradm (c) 2002-2006 	Brad Spengler 		        http://grsecurity.net#
 #--------------------------------------			---------------------#
 #gradm is licensed under the GNU GPL v2 or higher http://www.gnu.org         #
 ##############################################################################
@@ -23,7 +23,7 @@
 STRIP=/usr/bin/strip
 LIBS := $(shell if [ "`uname -m`" != "sparc64" ]; then echo "-lfl" ; else echo "" ; fi)
 OPT_FLAGS := $(shell if [ "`uname -m`" != "sparc64" ] && [ "`uname -m`" != "x86_64" ]; then echo "-O2" ; else echo "-O2 -m64" ; fi)
-CFLAGS := $(OPT_FLAGS) -DGRSEC_DIR=\"$(GRSEC_DIR)\"
+CFLAGS := $(OPT_FLAGS) -DGRSEC_DIR=\"$(GRSEC_DIR)\" -D_LARGEFILE64_SOURCE
 LDFLAGS=
 INSTALL = /usr/bin/install -c
 
@@ -41,7 +41,7 @@
 	gradm_sym.o gradm_newlearn.o gradm_fulllearn.o gradm_lib.o \
 	lex.fulllearn_pass1.o lex.fulllearn_pass2.o \
 	lex.fulllearn_pass3.o lex.learn_pass1.o lex.learn_pass2.o \
-	grlearn_config.tab.o lex.grlearn_config.o
+	grlearn_config.tab.o lex.grlearn_config.o gradm_globals.o
 
 all: $(GRADM_BIN) $(GRADM_PAM) grlearn
 nopam: $(GRADM_BIN) grlearn

## gradm2 2.1.14~200910072130

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
 ##############################################################################
-#gradm (c) 2002-2006 	Brad Spengler 		        http://grsecurity.net#
-#--------------------------------------			---------------------#
-#gradm is licensed under the GNU GPL v2 or higher http://www.gnu.org         #
+# gradm (c) 2002-2009 - Brad Spengler, Open Source Security Inc.             #
+# http://www.grsecurity.net                                                  #
+#----------------------------------------------------------------------------#
+# gradm is licensed under the GNU GPL v2 or higher http://www.gnu.org        #
 ##############################################################################
 
 GRADM_BIN=gradm
@@ -12,9 +13,11 @@
 FLEX=/usr/bin/flex
 LEX := $(shell if [ -x $(FLEX) ]; then echo $(FLEX); else echo $(LLEX); fi)
 LEXFLAGS=-B
-BYACC=/usr/bin/byacc
+#ubuntu broke byacc for who knows why, disable it
+#BYACC=/usr/bin/byacc
 BISON=/usr/bin/bison
-YACC := $(shell if [ -x $(BYACC) ]; then echo $(BYACC); else echo $(BISON); fi)
+#YACC := $(shell if [ -x $(BYACC) ]; then echo $(BYACC); else echo $(BISON); fi)
+YACC=$(BISON)
 MKNOD=/bin/mknod
 #for dietlibc
 #CC=/usr/bin/diet /usr/bin/gcc
@@ -41,7 +44,8 @@
 	gradm_sym.o gradm_newlearn.o gradm_fulllearn.o gradm_lib.o \
 	lex.fulllearn_pass1.o lex.fulllearn_pass2.o \
 	lex.fulllearn_pass3.o lex.learn_pass1.o lex.learn_pass2.o \
-	grlearn_config.tab.o lex.grlearn_config.o gradm_globals.o
+	grlearn_config.tab.o lex.grlearn_config.o gradm_globals.o \
+	gradm_replace.o
 
 all: $(GRADM_BIN) $(GRADM_PAM) grlearn
 nopam: $(GRADM_BIN) grlearn

## gradm2 2.9~201202232055

=== debian/changelog ===
gradm2 (2.9~201202232055-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.9.3 and make the package conforms to it.
  * Switch to 3.0 (quilt) source format, convert changes to patches.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Thu, 07 Jun 2012 00:21:07 +0200

gradm2 (2.1.14~200910072130-1) unstable; urgency=low

  * New upstream release (closes: #517634).
  * Don't create/remove /dev/grsec during install (closes: #552675, #552689),
    note this in README.Debian .
  * Suggest the real kernel package (closes: #517633) not the transition one.
  * Update Standards-Version to 3.8.3, move debhelper compatibility to
    version 5.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Thu, 19 Nov 2009 20:13:52 +0000

gradm2 (2.1.11-2) unstable; urgency=low

  * Delete duplicated policy entries (closes: #492351). Thanks to Olivier
    Tetard for helping identify the startup problem.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Fri, 25 Jul 2008 15:14:11 +0000

gradm2 (2.1.11-1) unstable; urgency=low

  * New stable upstream release.
  * Fix my mess mixing gradm2 internals with older version (closes: #482626).
  * Fix bashism in postinst (closes: #480598).
  * Update Standards-Version to 3.8.0, no changes needed.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Sat, 07 Jun 2008 20:25:49 +0000

gradm2 (2.1.11~200804041607-1) unstable; urgency=low

  * New test upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Tue, 08 Apr 2008 00:00:33 +0200

gradm2 (2.1.11~200803171746-1) unstable; urgency=low

  * New test upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Tue, 18 Mar 2008 16:35:20 +0100

gradm2 (2.1.11~200708011700-1) unstable; urgency=low

  * New test upstream release.
  * Modify upstream Makefile not to strip binaries if DEB_BUILD_OPTIONS
    contains nostrip (closes: #437079).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Sun, 20 Jan 2008 23:38:00 +0200

gradm2 (2.1.9-3) unstable; urgency=low

  * Removed debconf abuse, so created README.Debian and NEWS.Debian with
    translated versions (closes: #388898, #316834).
  * Added German (closes: #397190) and Portuguese (closes: #413930)
    translations; updated Swedish and Czech translations.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Thu,  8 Mar 2007 23:29:57 +0000

gradm2 (2.1.9-2) unstable; urgency=low

  * Updated release to perform an additional check for bad policies.
  * Updated Japanese debconf translation (closes: #394525).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Tue, 31 Oct 2006 20:06:21 +0000

gradm2 (2.1.9-1) unstable; urgency=low

  * New upstream release.
  * Update Dutch debconf translation, thanks to Kurt De Bree (closes: #377253).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Wed,  9 Aug 2006 20:18:50 +0200

gradm2 (2.1.8-1) unstable; urgency=medium

  * New upstream release.
  * Urgency set to medium to follow kernel-patch-grsecurity2 2.1.8-1, as
    that's a security fix release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Sat, 21 Jan 2006 21:13:06 +0000

gradm2 (2.1.7-3) unstable; urgency=low

  * Fix FTBFS on sparc64, due to libpam missing, thanks to Blars Blarson
    <blarson@blars.org> (closes: #342581).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Fri,  9 Dec 2005 04:54:10 +0000

gradm2 (2.1.7-2) unstable; urgency=low

  * Correct grsec device to be minor 13 instead of 12 (closes: #341707).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Tue,  6 Dec 2005 10:43:52 +0100

gradm2 (2.1.7-1) unstable; urgency=low

  * New upstream release.
  * Added Swedish debconf translation, thanks to Daniel Nylander
    <yeager@lidkoping.net> (closes: #332402).
  * Updated Czech debconf translation, thanks to Miroslav Kure again,
    (closes: #322428).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Sun, 27 Nov 2005 07:54:42 +0000

gradm2 (2.1.6-2) unstable; urgency=low

  * Updated Vietnamese debconf translations, thanks to Clytie Siddall
    <clytie@riverland.net.au> (closes: #316053).
  * Updated French debconf translations, thanks to Eric <eric-m@wanadoo.fr>
    (closes: #317781).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Wed, 20 Jul 2005 01:31:44 +0200

gradm2 (2.1.6-1) unstable; urgency=low

  * New major upstream release.
  * Added Czech debconf translations, thanks to Miroslav Kure
    <kurem@upcase.inf.upol.cz> (closes: #310256).
  * Added Vietnamese debconf translations, thanks to Clytie Siddall
    <clytie@riverland.net.au> (closes: #311885).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Wed, 15 Jun 2005 23:19:35 +0200

gradm2 (2.1.5-2) unstable; urgency=medium

  * Don't just call the kernel dependant gradm2 binary, but exec it,
    so role authentication does not get unauthenticated immediately because
    the parent process finishes. Thanks to Jan Krueger <jast@heapsort.de>
    (closes: #305176).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Mon, 18 Apr 2005 18:29:24 +0200

gradm2 (2.1.5-1) unstable; urgency=low

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Sat,  9 Apr 2005 07:33:25 +0200

gradm2 (2.1.4-1) unstable; urgency=medium

  * New upstream release. Urgency is medium becuase this version is
    needed for the grsecurity2 new features.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Tue, 22 Mar 2005 23:26:13 +0100

gradm2 (2.1.3-1) unstable; urgency=medium

  * New upstream release for the new grsecurity security fixes. As that
    require this version, urgency set to medium.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Mon,  7 Mar 2005 22:01:59 +0100

gradm2 (2.1.2-1) unstable; urgency=medium

  * New upstream release, urgency set because it is important for
    grsecurity2, which is a security release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Sat,  5 Mar 2005 10:21:34 +0100

gradm2 (2.1.1-1) unstable; urgency=low

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Sat, 12 Feb 2005 00:32:17 +0100

gradm2 (2.0.2-1) unstable; urgency=low



=== debian/control ===
Source: gradm2
Section: admin
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.hu>
Build-Depends: debhelper (>= 8), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
Standards-Version: 3.9.3
Homepage: http://www.grsecurity.net/

Package: gradm2
Architecture: any
Suggests: linux-patch-grsecurity2
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Administration program for the grsecurity2 RBAC based ACL system
 Used to manage the RBAC based ACL system of grsecurity2. Please note that you
 will need a specially patched kernel for grsecurity to work (see the
 kernel-patch-grsecurity2 Debian package). You can find more information
 about grsecurity at http://www.grsecurity.net/

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DESTDIR = $(CURDIR)/debian/gradm2

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

clean:
	dh_testdir

	rm -f install-stamp build-stamp
	rm -rf $(DESTDIR)
	$(MAKE) clean
	dh_clean

build-arch: build-stamp
build-indep: build-stamp

build: build-arch build-indep

build-stamp:
	dh_testdir

	$(MAKE)
	touch $@

install: install-stamp

install-stamp: build
	dh_testdir

	$(MAKE) install DESTDIR=$(DESTDIR)
	install -m644 $(CURDIR)/gradm.8 $(DESTDIR)/usr/share/man/man8/gradm2.8
	rm -rf $(DESTDIR)/dev/
	install -d $(DESTDIR)/usr/share/lintian/overrides/
	install -m0644 $(CURDIR)/debian/lintian.overrides $(DESTDIR)/usr/share/lintian/overrides/gradm2
	touch $@

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_installdocs
	dh_installman debian/grlearn.8
	dh_installchangelogs
	dh_compress
	dh_strip
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: clean build binary-indep binary-arch binary install

## gradm2 2.9.1~201206091838

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 ##############################################################################
-# gradm (c) 2002-2009 - Brad Spengler, Open Source Security Inc.             #
+# gradm (c) 2002-2011 - Brad Spengler, Open Source Security Inc.             #
 # http://www.grsecurity.net                                                  #
 #----------------------------------------------------------------------------#
 # gradm is licensed under the GNU GPL v2 or higher http://www.gnu.org        #
@@ -24,9 +24,9 @@
 CC=/usr/bin/gcc
 FIND=/usr/bin/find
 STRIP=/usr/bin/strip
-LIBS := $(shell if [ "`uname -m`" != "sparc64" ]; then echo "-lfl" ; else echo "" ; fi)
+LIBS := $(shell if [ "`uname -m`" != "sparc64" -a "`uname -m`" != "x86_64" ]; then echo "-lfl" ; else echo "" ; fi)
 OPT_FLAGS := $(shell if [ "`uname -m`" != "sparc64" ] && [ "`uname -m`" != "x86_64" ]; then echo "-O2" ; else echo "-O2 -m64" ; fi)
-CFLAGS := $(OPT_FLAGS) -DGRSEC_DIR=\"$(GRSEC_DIR)\" -D_LARGEFILE64_SOURCE
+CFLAGS := $(OPT_FLAGS) -Wcast-qual -DGRSEC_DIR=\"$(GRSEC_DIR)\" -D_LARGEFILE64_SOURCE
 LDFLAGS=
 INSTALL = /usr/bin/install -c
 
@@ -60,8 +60,8 @@
 		$(CC) $(CFLAGS) -o $@ gradm_pam.c -lpam -lpam_misc $(LDFLAGS) ; \
 	fi
 
-grlearn: grlearn.c gradm_lib.c grlearn2_config.tab.c lex.grlearn_config.c
-	$(CC) $(CFLAGS) -DIS_GRLEARN -o $@ grlearn.c gradm_lib.c grlearn2_config.tab.c lex.grlearn_config.c $(LIBS) $(LDFLAGS)
+grlearn: grlearn.c gradm_lib.c gradm_globals.c grlearn2_config.tab.c lex.grlearn_config.c
+	$(CC) $(CFLAGS) -DIS_GRLEARN -o $@ grlearn.c gradm_lib.c gradm_globals.c grlearn2_config.tab.c lex.grlearn_config.c $(LIBS) $(LDFLAGS)
 
 grlearn2_config.tab.c: grlearn2_config.y
 	$(YACC) -b grlearn2_config -p grlearn2_config -d ./grlearn2_config.y
@@ -134,6 +134,14 @@
 			$(MKNOD) -m 0622 $(DESTDIR)/dev/grsec c 1 13 ; \
 		fi \
 	fi
+	@if [ -d $(DESTDIR)/etc/udev/rules.d ] ; then \
+		echo "ACTION!=\"add|change\", GOTO=\"permissions_end\"" > $(DESTDIR)/etc/udev/rules.d/80-grsec.rules ; \
+		echo "KERNEL==\"grsec\",          MODE=\"0622\"" >> $(DESTDIR)/etc/udev/rules.d/80-grsec.rules ; \
+		echo "LABEL=\"permissions_end\"" >> $(DESTDIR)/etc/udev/rules.d/80-grsec.rules ; \
+	fi
+	@if [ -f $(DESTDIR)/sbin/udevadm ] ; then \
+		$(DESTDIR)/sbin/udevadm trigger --action=change ; \
+	fi
 	@echo "Installing gradm manpage..."
 	@mkdir -p $(DESTDIR)$(MANDIR)/man8
 	@$(INSTALL) -m 0644 gradm.8 $(DESTDIR)$(MANDIR)/man8/$(GRADM_BIN).8

=== debian/changelog ===
gradm2 (2.9.1~201206091838-1) unstable; urgency=low

  * New upstream release (closes: #605263).
  * Update patches to match this release.
  * Only Linux is supported, make the package linux-any .
  * Build with hardening enabled, change upstream build to make this possible.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Wed, 20 Jun 2012 22:53:27 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Homepage: http://www.grsecurity.net/
 
 Package: gradm2
-Architecture: any
+Architecture: linux-any
 Suggests: linux-patch-grsecurity2
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Administration program for the grsecurity2 RBAC based ACL system

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,13 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
+
+CFLAGS		?= $(shell dpkg-buildflags --get CFLAGS)
+CPPFLAGS	?= $(shell dpkg-buildflags --get CPPFLAGS)
+LDFLAGS		?= $(shell dpkg-buildflags --get LDFLAGS)
+CFLAGS		+= $(HARDENING_CFLAGS) -fPIC
+CPPFLAGS	+= $(HARDENING_CFLAGS)
+LDFLAGS		+= $(HARDENING_LDFLAGS)
 
 DESTDIR = $(CURDIR)/debian/gradm2
 
@@ -36,6 +43,7 @@
 build-stamp:
 	dh_testdir
 
+#	LDFLAGS="${LDFLAGS}" $(MAKE)
 	$(MAKE)
 	touch $@

## gradm2 2.9.1~201301041755

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 LLEX=/usr/bin/lex
 FLEX=/usr/bin/flex
 LEX := $(shell if [ -x $(FLEX) ]; then echo $(FLEX); else echo $(LLEX); fi)
-LEXFLAGS=-B
+LEXFLAGS=-Cfa -B
 #ubuntu broke byacc for who knows why, disable it
 #BYACC=/usr/bin/byacc
 BISON=/usr/bin/bison
@@ -63,26 +63,42 @@
 grlearn: grlearn.c gradm_lib.c gradm_globals.c grlearn2_config.tab.c lex.grlearn_config.c
 	$(CC) $(CFLAGS) -DIS_GRLEARN -o $@ grlearn.c gradm_lib.c gradm_globals.c grlearn2_config.tab.c lex.grlearn_config.c $(LIBS) $(LDFLAGS)
 
-grlearn2_config.tab.c: grlearn2_config.y
+grlearn2_config.tab.c grlearn2_config.tab.h: grlearn2_config_tab_c_h_wrapper
+
+grlearn2_config_tab_c_h_wrapper: grlearn2_config.y
 	$(YACC) -b grlearn2_config -p grlearn2_config -d ./grlearn2_config.y
 
-grlearn_config.tab.c: grlearn_config.y
+grlearn_config.tab.c grlearn_config.tab.h: grlearn_config_tab_c_h_wrapper
+
+grlearn_config_tab_c_h_wrapper: grlearn_config.y
 	$(YACC) -b grlearn_config -p grlearn_config -d ./grlearn_config.y
 
 lex.grlearn_config.c: grlearn_config.l
 	$(LEX) $(LEXFLAGS) -Pgrlearn_config ./grlearn_config.l
 
-gradm.tab.c: gradm.y
+lex.grlearn_config.o: lex.grlearn_config.c grlearn_config.tab.h
+
+gradm.tab.c gradm.tab.h: gradm_tab_c_h_wrapper
+
+gradm_tab_c_h_wrapper: gradm.y
 	$(YACC) -b gradm -p gradm -d ./gradm.y
 
 lex.gradm.c: gradm.l
 	$(LEX) $(LEXFLAGS) -Pgradm ./gradm.l
 
-fulllearn_pass1.tab.c: gradm_fulllearn_pass1.y
+lex.gradm.o: lex.gradm.c gradm.tab.h
+
+fulllearn_pass1.tab.c fulllearn_pass1.tab.h: fulllearn_pass1_tab_c_h_wrapper
+
+fulllearn_pass2.tab.c fulllearn_pass2.tab.h: fulllearn_pass2_tab_c_h_wrapper
+
+fulllearn_pass3.tab.c fulllearn_pass3.tab.h: fulllearn_pass3_tab_c_h_wrapper
+
+fulllearn_pass1_tab_c_h_wrapper: gradm_fulllearn_pass1.y
 	$(YACC) -b fulllearn_pass1 -p fulllearn_pass1 -d ./gradm_fulllearn_pass1.y
-fulllearn_pass2.tab.c: gradm_fulllearn_pass2.y
+fulllearn_pass2_tab_c_h_wrapper: gradm_fulllearn_pass2.y
 	$(YACC) -b fulllearn_pass2 -p fulllearn_pass2 -d ./gradm_fulllearn_pass2.y
-fulllearn_pass3.tab.c: gradm_fulllearn_pass3.y
+fulllearn_pass3_tab_c_h_wrapper: gradm_fulllearn_pass3.y
 	$(YACC) -b fulllearn_pass3 -p fulllearn_pass3 -d ./gradm_fulllearn_pass3.y
 
 lex.fulllearn_pass1.c: gradm_fulllearn_pass1.l
@@ -92,15 +108,30 @@
 lex.fulllearn_pass3.c: gradm_fulllearn_pass3.l
 	$(LEX) $(LEXFLAGS) -Pfulllearn_pass3 ./gradm_fulllearn_pass3.l
 
-learn_pass1.tab.c: gradm_learn_pass1.y
+lex.fulllearn_pass1.o: lex.fulllearn_pass1.c fulllearn_pass1.tab.h
+
+lex.fulllearn_pass2.o: lex.fulllearn_pass2.c fulllearn_pass2.tab.h
+
+lex.fulllearn_pass3.o: lex.fulllearn_pass3.c fulllearn_pass3.tab.h
+
+learn_pass1.tab.c learn_pass1.tab.h: learn_pass1_tab_c_h_wrapper
+
+learn_pass1_tab_c_h_wrapper: gradm_learn_pass1.y
 	$(YACC) -b learn_pass1 -p learn_pass1 -d ./gradm_learn_pass1.y
-learn_pass2.tab.c: gradm_learn_pass2.y
+
+learn_pass2.tab.c learn_pass2.tab.h: learn_pass2_tab_c_h_wrapper
+
+learn_pass2_tab_c_h_wrapper: gradm_learn_pass2.y
 	$(YACC) -b learn_pass2 -p learn_pass2 -d ./gradm_learn_pass2.y
 
 lex.learn_pass1.c: gradm_learn_pass1.l
 	$(LEX) $(LEXFLAGS) -Plearn_pass1 ./gradm_learn_pass1.l
 lex.learn_pass2.c: gradm_learn_pass2.l
 	$(LEX) $(LEXFLAGS) -Plearn_pass2 ./gradm_learn_pass2.l
+
+lex.learn_pass1.o: lex.learn_pass1.c learn_pass1.tab.h
+
+lex.learn_pass2.o: lex.learn_pass2.c learn_pass2.tab.h
 
 install: $(GRADM_BIN) gradm.8 policy grlearn
 	@mkdir -p $(DESTDIR)/sbin

=== debian/changelog ===
gradm2 (2.9.1~201301041755-1) unstable; urgency=low

  * New upstream release.
  * Move to Standards-Version 3.9.4 and to debhelper level 9 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.hu>  Sat, 16 Mar 2013 21:58:04 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: admin
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.hu>
-Build-Depends: debhelper (>= 8), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
+Standards-Version: 3.9.4
 Homepage: http://www.grsecurity.net/
 
 Package: gradm2

## gradm2 2.9.1~201309161709

=== Makefile ===
--- 
+++ 
@@ -25,7 +25,9 @@
 FIND=/usr/bin/find
 STRIP=/usr/bin/strip
 LIBS := $(shell if [ "`uname -m`" != "sparc64" -a "`uname -m`" != "x86_64" ]; then echo "-lfl" ; else echo "" ; fi)
-OPT_FLAGS := $(shell if [ "`uname -m`" != "sparc64" ] && [ "`uname -m`" != "x86_64" ]; then echo "-O2" ; else echo "-O2 -m64" ; fi)
+OPT_FLAGS := -O2
+# for older versions of grsecurity, comment the above line and uncomment the below:
+#OPT_FLAGS := $(shell if [ "`uname -m`" != "sparc64" ] && [ "`uname -m`" != "x86_64" ]; then echo "-O2" ; else echo "-O2 -m64" ; fi)
 CFLAGS := $(OPT_FLAGS) -Wcast-qual -DGRSEC_DIR=\"$(GRSEC_DIR)\" -D_LARGEFILE64_SOURCE
 LDFLAGS=
 INSTALL = /usr/bin/install -c

=== debian/changelog ===
gradm2 (2.9.1~201309161709-1) unstable; urgency=low

  * New upstream release.
  * Rework patches:
    - make those apply clean;
    - drop 05-add_format.patch as applied upstream;
    - drop 10-fix_pam_linking_on_sparc.patch as not needed anymore;
    - add 15-update-selinux-path.patch for changing SELinux default path
      (closes: #707221).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 19 Sep 2013 08:11:58 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: gradm2
 Section: admin
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.hu>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
 Standards-Version: 3.9.4
 Homepage: http://www.grsecurity.net/

## gradm2 3.0~201311242038

=== debian/changelog ===
gradm2 (3.0~201311242038-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.9.5 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 28 Dec 2013 15:24:56 +0100

## gradm2 3.0~201401282126

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,9 @@
 ##############################################################################
-# gradm (c) 2002-2011 - Brad Spengler, Open Source Security Inc.             #
+# gradm (c) 2002-2014 - Brad Spengler, Open Source Security Inc.             #
 # http://www.grsecurity.net                                                  #
 #----------------------------------------------------------------------------#
-# gradm is licensed under the GNU GPL v2 or higher http://www.gnu.org        #
+# gradm is licensed under the GNU GPL v2 only http://www.gnu.org             #
+# see COPYRIGHT and LICENSE files for more information                       #
 ##############################################################################
 
 GRADM_BIN=gradm

=== debian/changelog ===
gradm2 (3.0~201401282126-1) unstable; urgency=low

  * New upstream release.
  * Update patches.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 29 Jan 2014 17:59:19 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://www.grsecurity.net/
 
 Package: gradm2

=== debian/rules ===
--- 
+++ 
@@ -1,17 +1,12 @@
 #!/usr/bin/make -f
+# -*- makefile -*-
+
 # Uncomment this to turn on verbose mode.
-export DH_VERBOSE=1
+#export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
-
-CFLAGS		?= $(shell dpkg-buildflags --get CFLAGS)
-CPPFLAGS	?= $(shell dpkg-buildflags --get CPPFLAGS)
-LDFLAGS		?= $(shell dpkg-buildflags --get LDFLAGS)
-CFLAGS		+= $(HARDENING_CFLAGS) -fPIC
-CPPFLAGS	+= $(HARDENING_CFLAGS)
-LDFLAGS		+= $(HARDENING_LDFLAGS)
 
 DESTDIR = $(CURDIR)/debian/gradm2
 
@@ -42,8 +37,6 @@
 
 build-stamp:
 	dh_testdir
-
-#	LDFLAGS="${LDFLAGS}" $(MAKE)
 	$(MAKE)
 	touch $@

## gradm2 3.0~201408301734

=== debian/changelog ===
gradm2 (3.0~201408301734-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.9.6 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 16 Oct 2014 18:53:28 +0200

## gradm2 3.1~201503211320

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 ##############################################################################
-# gradm (c) 2002-2014 - Brad Spengler, Open Source Security Inc.             #
+# gradm (c) 2002-2015 - Brad Spengler, Open Source Security Inc.             #
 # http://www.grsecurity.net                                                  #
 #----------------------------------------------------------------------------#
 # gradm is licensed under the GNU GPL v2 only http://www.gnu.org             #
@@ -29,8 +29,8 @@
 OPT_FLAGS := -O2
 # for older versions of grsecurity, comment the above line and uncomment the below:
 #OPT_FLAGS := $(shell if [ "`uname -m`" != "sparc64" ] && [ "`uname -m`" != "x86_64" ]; then echo "-O2" ; else echo "-O2 -m64" ; fi)
-CFLAGS := $(OPT_FLAGS) -Wcast-qual -DGRSEC_DIR=\"$(GRSEC_DIR)\" -D_LARGEFILE64_SOURCE
-LDFLAGS=
+CFLAGS := $(OPT_FLAGS) -fPIE -Wcast-qual -DGRSEC_DIR=\"$(GRSEC_DIR)\" -D_LARGEFILE64_SOURCE
+LDFLAGS= -pie
 INSTALL = /usr/bin/install -c
 
 # FHS

=== debian/changelog ===
gradm2 (3.1~201503211320-2) unstable; urgency=low

  * Apply all patches.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 04 Jun 2015 21:02:01 +0000

gradm2 (3.1~201503211320-1) unstable; urgency=low

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 25 Apr 2015 20:23:26 +0000

## gradm2 3.1~201507191652

=== debian/changelog ===
gradm2 (3.1~201507191652-2) unstable; urgency=low

  * Switch back to grsec device (closes: #813401).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 17 Feb 2016 23:26:44 +0100

gradm2 (3.1~201507191652-1) unstable; urgency=low

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 09 Jan 2016 08:27:31 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.grsecurity.net/
 
 Package: gradm2

## gradm2 3.1~201603152148

=== debian/changelog ===
gradm2 (3.1~201603152148-1) unstable; urgency=low

  * New upstream release.
  * Delete /dev/grsec device if it exists (closes: #788492).
  * Update Standards-Version to 3.9.7 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 21 Mar 2016 17:58:53 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://www.grsecurity.net/
 
 Package: gradm2

## gradm2 3.1~201608131257

=== debian/changelog ===
gradm2 (3.1~201608131257-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.9.8 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 26 Nov 2016 15:22:08 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://www.grsecurity.net/
 
 Package: gradm2

## gradm2 3.1~201701031918

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 LLEX=/usr/bin/lex
 FLEX=/usr/bin/flex
 LEX := $(shell if [ -x $(FLEX) ]; then echo $(FLEX); else echo $(LLEX); fi)
-LEXFLAGS=-Cfa -B
+LEXFLAGS=-Cfa -B -8
 #ubuntu broke byacc for who knows why, disable it
 #BYACC=/usr/bin/byacc
 BISON=/usr/bin/bison

=== debian/changelog ===
gradm2 (3.1~201701031918-2build1) bionic; urgency=medium

  * No-change rebuild to pick up the shared flex library.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 Feb 2018 07:01:43 +0000

gradm2 (3.1~201701031918-2) unstable; urgency=low

  * Update udevadm path (closes: #852565).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 25 Jan 2017 16:28:05 +0000

gradm2 (3.1~201701031918-1) unstable; urgency=low

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 15 Jan 2017 14:47:17 +0000

gradm2 (3.1~201608131257-2) unstable; urgency=low

  * Add libfl-dev to build depends (closes: #849666).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 30 Dec 2016 14:33:11 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), bison, flex, libfl-dev, libpam0g-dev
 Standards-Version: 3.9.8
 Homepage: http://www.grsecurity.net/

## gradm2 3.1~201709030627

=== debian/changelog ===
gradm2 (3.1~201709030627-1) unstable; urgency=medium

  * New upstream release.
  * Migrate d/copyright to format 1.0 .
  * Update debhelper level to 11 .
  * Update Standards-Version to 4.1.4 .

  [ Adrian Bunk <bunk@debian.org> ]
  * Fix FTBFS on !x86/sparc64 with recent flex (closes: #896166).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 20 Apr 2018 15:20:40 +0000

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: admin
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), bison, flex, libfl-dev, libpam0g-dev
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.1~), bison, flex, libpam0g-dev
+Standards-Version: 4.1.4
 Homepage: http://www.grsecurity.net/
 
 Package: gradm2

## gradm2 3.1~201903191516

=== debian/changelog ===
gradm2 (3.1~201903191516-1) unstable; urgency=medium

  * New upstream release.
  * Don't suggest no longer existing linux-patch-grsecurity2 package
    (closes: #961769).
  * Remove outdated Debian NEWS.
  * Update Standards-Version to 4.5.0 .

  [ Helmut Grohne <helmut@subdivi.de> ]
  * Fix FTCBFS (closes: #948434):
    + Let dh_auto_build pass cross tools to make.
    + cross.patch: Don't rebuild on every make invocation.
    + Don't strip during make install.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 30 May 2020 06:57:02 +0200

=== debian/control ===
Source: gradm2
Section: admin
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 11), bison, flex, libpam0g-dev
Standards-Version: 4.5.0
Homepage: https://www.grsecurity.net/

Package: gradm2
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Administration program for the grsecurity2 RBAC based ACL system
 Used to manage the RBAC based ACL system of grsecurity2. Please note that you
 will need a specially patched kernel for grsecurity to work (see the
 kernel-patch-grsecurity2 Debian package). You can find more information
 about grsecurity at http://www.grsecurity.net/

=== debian/rules ===
--- 
+++ 
@@ -37,7 +37,7 @@
 
 build-stamp:
 	dh_testdir
-	$(MAKE)
+	dh_auto_build
 	touch $@
 
 install: install-stamp
@@ -45,7 +45,7 @@
 install-stamp: build
 	dh_testdir
 
-	$(MAKE) install DESTDIR=$(DESTDIR)
+	$(MAKE) install DESTDIR=$(DESTDIR) STRIP=true
 	install -m644 $(CURDIR)/gradm.8 $(DESTDIR)/usr/share/man/man8/gradm2.8
 	rm -rf $(DESTDIR)/dev/
 	install -d $(DESTDIR)/usr/share/lintian/overrides/
